import time
import thread
import threading

class Timer:
    def __init__(self, interval, callback):
        self.interval = interval
        self.callback = callback
        self.running = 0

    def start(self):
        if self.running:
            pass
        self.running = 1
        self.thread = threading.Thread(target=self.runloop)
        self.thread.start()

    def runloop(self):
        while self.running:
            time.sleep(self.interval)
            self.invokeCallback()
        self.running = 0
        self.thread = None

    def stop(self):
        if not self.running:
            pass
        self.running = 0

    def invokeCallback(self):
        self.callback(self)
